package Package1;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class NotesButtons extends JFrame implements ActionListener {

    JLabel labelSelectedNote;
    JButton buttonReset;
    
    public enum Note {
        C, Db, D, Eb, E, F, Gb, G, Ab, A, Bb, B
    };

    public NotesButtons() {
        super("NotesButtons");
        setSize(480, 200);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new FlowLayout());
        
        for (Note n : Note.values()) {
            JButton button = new JButton(n.toString());
            add(button);
            // Si crea direttamente qui l'ActionListener richiamando 
            // poi un metodo comune a tutti i pulsanti delle note
            // In alternativa si poteva usare come listener il JFrame
            // ma occorreva discernere tra il pulsante Reset e i pulsanti delle note
            button.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    noteSelected(e);
                }
            });
        }
        buttonReset = new JButton("Reset");
        buttonReset.addActionListener(this);
        labelSelectedNote = new JLabel();
        labelSelectedNote.setFont(new Font("Arial", Font.BOLD, 18));
        add(labelSelectedNote);
        add(buttonReset);
    }

    public static void main(String[] args) {
        NotesButtons frame = new NotesButtons();
        frame.setVisible(true);
    }

    private void noteSelected(ActionEvent e) {
        Object o = e.getSource();
        JButton b;
        if (o instanceof JButton) {
            b = (JButton)o;
            labelSelectedNote.setText(labelSelectedNote.getText() + " " + b.getText());
        }
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        // L'unico componente che scatena l'evento intercettato è il pulsante Reset,
        // ma per non incorrere in errori alla modifica del sorgente meglio
        // gestirlo esplicitamente (anche per l'alternativa al metodo noteSelected, ad esempio)
        if (e.getSource() == buttonReset)
            labelSelectedNote.setText("");
    }
}
