package Package1;


import java.io.IOException;
import java.util.TreeMap;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class XPathAnalysis {
    static class MaxItem {
        public float floatDuration = 0;
        public int num = 0;
        public int den = 1;
        public Element durationElement;

        private MaxItem() {
            this(0, 1, 0, null);
        }
        
        private MaxItem(Integer n, Integer d, float dur, Element el) {
            num = n;
            den = d;
            floatDuration = dur;
            durationElement = el;
        }
    }
    
    public static void main(String[] args) throws TransformerException {

        try {
            DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
            Document myXmlDocument = docBuilder.parse("gounod_ave_maria.xml");

            XPathFactory myXPathFactory = XPathFactory.newInstance();
            XPath myXPath = myXPathFactory.newXPath();

            TreeMap<Integer, MaxItem> maxs = new TreeMap<>();
            NodeList currentDurations = (NodeList) (myXPath.evaluate("/ieee1599/logic/los/part/measure/voice/chord/duration",
                    myXmlDocument, XPathConstants.NODESET)); // sostituendo chord con * avremmo considerato anche le pause
            XPathExpression myXPathExpression = myXPath.compile("../../../@number"); // compilazione preventiva: più veloce poi la valutazione
            for (int i = 0; i < currentDurations.getLength(); i++) {
                String measure = myXPathExpression.evaluate(currentDurations.item(i));
                Integer currentMeasure = Integer.parseInt(measure);
                String currentNumString = ((Element) (currentDurations.item(i))).getAttribute("num");
                Integer currentNum = Integer.parseInt(currentNumString);
                String currentDenString = ((Element) (currentDurations.item(i))).getAttribute("den");
                Integer currentDen = Integer.parseInt(currentDenString);
                float floatDuration = (float) currentNum / currentDen;
                if (!maxs.containsKey(currentMeasure) || maxs.get(currentMeasure).floatDuration <= floatDuration)
                    maxs.put(currentMeasure, new MaxItem(currentNum, currentDen, floatDuration, (Element) (currentDurations.item(i))));
            }
            for (Integer i : maxs.keySet()) {
                System.out.print("Valore massimo per battuta " + i + ": " + maxs.get(i).num + "/" + maxs.get(i).den);
                System.out.println(" eseguita da " + myXPath.evaluate("ancestor::part/@id", maxs.get(i).durationElement));
            }
        } catch (ParserConfigurationException | SAXException | IOException | XPathExpressionException | NumberFormatException ex) {
        }
    }

}
