package audio;

import java.util.Random;

public class Additive2 {

    public static class WaveDataAdd extends Additive1.WaveDataAdd {

        public void addVariable(int nSamples, double normalizedAmplitude, double frequency) {
            audioSamples.clear();

            if (Math.abs(normalizedAmplitude) > 1)
                normalizedAmplitude = 1;
            short amplitude = (short) (32767 * Math.abs(normalizedAmplitude) / 3); // un terzo dell'ampiezza massima

            double nFreqs1 = (frequency * 1.1 - frequency) / nSamples;
            double nFreqs2 = (frequency * 1.5 - frequency) / nSamples;
            double nFreqs3 = (frequency * 2.0 - frequency) / nSamples;

            double f1 = frequency;
            double f2 = frequency;
            double f3 = 2 * frequency;

            for (int i = 0; i < nSamples; i++) {
                double nSamplesPerCycle1 = 44100 / f1;
                double nSamplesPerCycle2 = 44100 / f2;
                double nSamplesPerCycle3 = 44100 / f3;

                double a1 = amplitude * Math.sin(2 * Math.PI * (i / nSamplesPerCycle1));
                double a2 = amplitude * Math.sin(2 * Math.PI * (i / nSamplesPerCycle2));
                double a3 = amplitude * Math.sin(2 * Math.PI * (i / nSamplesPerCycle3));

                Sample s = new Sample((short)(a1 + a2 + a3), (short)(a1 + a2 + a3));
                audioSamples.add(s);

                f1 += nFreqs1;
                f2 += nFreqs2;
                f3 -= nFreqs3;
            }
        }
    }
    
    public static void main(String[] args) {
        WaveDataAdd wd = new WaveDataAdd();
        wd.addVariable(88200, 1, 440);
        wd.saveSamplesToDisk("addVariable.wav");
    }
}
